# File: PloneGuestbookFolder.py
# 
# Copyright (c) 2005 by ['']
# Generator: ArchGenXML Version 1.4.0-RC2 svn/development 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Plone Multimedia Team <natea (at) jazkarta (dot) com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


# additional imports from tagged value 'import'
from Products.CMFCore.utils import getToolByName
from Products.PloneGuestbook import PloneGuestbookEntry
from Products.PloneGuestbook.PloneGuestbookEntry import PloneGuestbookEntrySchema
from cStringIO import StringIO
import os
import string
from Products.ATContentTypes.content.folder import ATFolder
from Products.ATContentTypes.content.folder import ATFolderSchema

from Products.PloneGuestbook.config import *
##code-section module-header #fill in your manual code here
from Acquisition import aq_self
from Products.CMFCore.permissions import View

if HAS_LINGUA_PLONE:
    from Products.LinguaPlone.public import *
##/code-section module-header

# do we need it?
schema=Schema((

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

PloneGuestbookFolderSchema = ATFolderSchema + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PloneGuestbookFolder(ATFolder):
    security = ClassSecurityInfo()
    __implements__ = (getattr(ATFolder,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'Guestbook'

    meta_type                  = 'GuestbookFolder'
    portal_type                = 'GuestbookFolder'
    allowed_content_types      = ['GuestbookEntry'] 
    filter_content_types       = 1
    global_allow               = 1
    allow_discussion           = 0
    content_icon               = 'ploneguestbookfolder.gif'
    immediate_view             = 'ploneguestbookfolder_dom_view'
    default_view               = 'ploneguestbookfolder_dom_view'
    suppl_views                = ('ploneguestbookfolder_dom_view','ploneguestbookfolder_view','ploneguestbookfolder_listing','folder_listing','folder_summary_view','folder_tabular_view' )
    typeDescription            = "Guestbook"
    typeDescMsgId              = 'description_edit_ploneguestbook'

    actions =  (


       {'action':      "string:${object_url}/view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


       {'action':      "string:${object_url}/ploneguestbookfolder_export",
        'category':    "object",
        'id':          'export',
        'name':        'Export',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


       {'action':      "string:${object_url}/ploneguestbookfolder_import",
        'category':    "object",
        'id':          'import',
        'name':        'Import',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },

    )

    schema = PloneGuestbookFolderSchema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePublic('getEntries')
    def getEntries(self,basepath=''):
        if(not basepath):
            basepath = self.getId()
        list = []
        dict = {}
        for object in self.listFolderContents():
            path = "%s/%s" % (basepath,object.getId())
            if(object.meta_type=='GuestbookEntry'):
                  list.append(object)
#                dict[path] = object
#        if(dict):
#            list.append(dict)
        return list

#    security.declarePublic('tag')
#    def tag(self,**kwargs):
#        """
#        return the tag of symbolic_photo
#        """
#        container = aq_self(self)
#        if IPossibleScalable.providedBy(container):
#            if not kwargs.has_key('scale'):
#                kwargs.setdefault('scale','thumb')
#            return IScalable(container).tag(**kwargs)
#        return ''

#    security.declarePublic('hasPloneJUpload')
#    def hasPloneJUpload(self):
#        """
#        test if we have PloneJUpload installed
#        """
#        qi = getToolByName(self,'portal_quickinstaller')
#        ploneJUpload = [prod for prod in qi.listInstalledProducts() if (prod['id']=='PloneJUpload')]
#        return (bool(ploneJUpload) and ploneJUpload[0]['status'] == 'installed')


#
#    security.declarePublic('importPhotos')
#    def importPhotos(self, zipFile, REQUEST=None):
#        """
#          Import photos from a zipFile
#        """
#        name, ext = os.path.splitext(zipFile.filename)
#        ext = string.lower(ext)
#        if(ext == '.zip'):
#            filesList = self.extractZipFile(zipFile)
#        elif(ext in ['.tar','.gz','.bz2']):
#            filesList = self.extractTarFile(zipFile, ext)
#        else:
#            msg = "Error: wrong extention! File must be zip, tar, gz or bz2"
#            if(REQUEST):
#                REQUEST.RESPONSE.redirect("%s/atphotoalbum_import?portal_status_message=%s" % (self.absolute_url(),msg))
#            return msg
#        for key in filesList:
#        #    data = StringIO( filesList[key] )
#            data = str(filesList[key])
#            self.invokeFactory('ATPhoto',key,RESPONSE=None)
#            atphoto = getattr(self,key)
#            atphoto.setImage(str(data))
#        msg = "Imported %s photos from file" % len(filesList)
#        if(REQUEST):
#            REQUEST.RESPONSE.redirect("%s/atphotoalbum_import?portal_status_message=%s" % (self.absolute_url(),msg))
#        return msg


registerType(PloneGuestbookFolder,PROJECTNAME)
# end of class PloneGuestbookFolder

##code-section module-footer #fill in your manual code here
##/code-section module-footer



